/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(SPEECH_SYNTHESIS)

#include "JSDOMWrapper.h"
#include "JSSpeechSynthesisEvent.h"
#include "SpeechSynthesisErrorEvent.h"

namespace WebCore {

class JSSpeechSynthesisErrorEvent : public JSSpeechSynthesisEvent {
public:
    using Base = JSSpeechSynthesisEvent;
    using DOMWrapped = SpeechSynthesisErrorEvent;
    static JSSpeechSynthesisErrorEvent* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<SpeechSynthesisErrorEvent>&& impl)
    {
        SUPPRESS_UNCOUNTED_LOCAL auto& vm = globalObject->vm();
        JSSpeechSynthesisErrorEvent* ptr = new (NotNull, JSC::allocateCell<JSSpeechSynthesisErrorEvent>(vm)) JSSpeechSynthesisErrorEvent(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(vm);
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::JSType(JSEventType), StructureFlags), info(), JSC::NonArray);
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    template<typename, JSC::SubspaceAccess mode> static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        if constexpr (mode == JSC::SubspaceAccess::Concurrently)
            return nullptr;
        return subspaceForImpl(vm);
    }
    static JSC::GCClient::IsoSubspace* subspaceForImpl(JSC::VM& vm);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    SpeechSynthesisErrorEvent& wrapped() const
    {
        return static_cast<SpeechSynthesisErrorEvent&>(Base::wrapped());
    }

    Ref<SpeechSynthesisErrorEvent> protectedWrapped() const;

protected:
    JSSpeechSynthesisErrorEvent(JSC::Structure*, JSDOMGlobalObject&, Ref<SpeechSynthesisErrorEvent>&&);

    DECLARE_DEFAULT_FINISH_CREATION;
};

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, SpeechSynthesisErrorEvent&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, SpeechSynthesisErrorEvent* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<SpeechSynthesisErrorEvent>&&);
ALWAYS_INLINE JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, SpeechSynthesisErrorEvent& impl) { return toJSNewlyCreated(lexicalGlobalObject, globalObject, Ref { impl }); }
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<SpeechSynthesisErrorEvent>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<SpeechSynthesisErrorEvent> {
    using WrapperClass = JSSpeechSynthesisErrorEvent;
    using ToWrappedReturnType = SpeechSynthesisErrorEvent*;
};

} // namespace WebCore

#endif // ENABLE(SPEECH_SYNTHESIS)
